#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "libpq-fe.h"
#include "config.h"

struct traff_st {
	char IPADDR[20];
	long bytes_in,bytes_out;
	long pack_in,pack_out;
};


int main()
{
	PGconn *conn;
	PGresult *res;
	char query[255];
	int i,j,k,len;
	char chainbuff[1024][255];
	FILE *chns;
	long pack,bytes;
	char IP1[20];
	struct traff_st traff[500];
	int tnum;
		
	
	conn=PQsetdbLogin(DBHOST,NULL,NULL,NULL,DBNAME,DBUSER,DBPASS);
	/* Spisuk s chainovete za otchitane*/
	res=PQexec(conn,"select value from config where name='acct_chain_pfx'");
	
	for (i=0;i<PQntuples(res);i++)
	{
		snprintf(query,250,"%s -L %s_in -vxn",IPCHAINS,PQgetvalue(res,i,0));
		chns=popen(query,"r");
		len=0;
		memset(chainbuff,0,1024*255);
		tnum=0;
		memset(traff,0,500*sizeof(struct traff_st));
		while (!feof(chns))
		{
			fgets(chainbuff[len],255,chns);
			len++;
		}
		pclose(chns);

		for (j=0;j<len;j++)
		{
			if ( (strstr(chainbuff[j],"RETURN")!=NULL) || (strstr(chainbuff[j],"destination")!=NULL) || (strstr(chainbuff[j],"Chain")!=NULL) || ( chainbuff[j][0]=='\0') )  continue;
		//	printf("%s",chainbuff[j]);
			sscanf(chainbuff[j],"%ld %ld %*s %*s %*s %*s %s %*s %*s %*s",&pack,&bytes,IP1);
			strcpy(traff[tnum].IPADDR,IP1);
			traff[tnum].pack_in=pack;
			traff[tnum].bytes_in=bytes;
			tnum++;
		}
		
		// output
		snprintf(query,250,"%s -L %s_out -vxn",IPCHAINS,PQgetvalue(res,i,0));
		chns=popen(query,"r");
		len=0;
		memset(chainbuff,0,1024*255);
		while (!feof(chns))
		{
			fgets(chainbuff[len],255,chns);
			len++;
		}
		pclose(chns);

		for (j=0;j<len;j++)
		{
			if ( (strstr(chainbuff[j],"RETURN")!=NULL) || (strstr(chainbuff[j],"destination")!=NULL) || (strstr(chainbuff[j],"Chain")!=NULL) || ( chainbuff[j][0]=='\0') )  continue;
		//	printf("%s",chainbuff[j]);
			sscanf(chainbuff[j],"%ld %ld %*s %*s %*s %*s %*s %s %*s %*s",&pack,&bytes,IP1);
		 	for (k=0;k<tnum+1;k++)
			{
				if (strcmp(IP1,traff[k].IPADDR)==0)
					break;
			};
			traff[k].bytes_out=bytes;
			traff[k].pack_out=pack;
		}
		for (j=0;j<tnum;j++)
		{
			if ( (traff[j].pack_in==0) && (traff[j].pack_out==0)) continue;
			printf("INSERT INTO traffdmp VALUES('%s',datetime(now()),%ld,%ld,%ld,%ld,'%s');\n",traff[j].IPADDR,traff[j].pack_in,traff[j].bytes_in,traff[j].pack_out,traff[j].bytes_out,PQgetvalue(res,i,0));
		}
		
	}

	return 0;
}
